<template>
  <div class="balancy-card">
    <v-card width="300px">
      <v-card-text>
        <div class="balancy-zones">

          <div class="mb-4">
            TOTAL PAX: <span class="font-weight-bold">{{ flight.paxs ? getPaxsByLeg.length : '' }}</span>
          </div>

          <div v-for="zone in zones" class="balancy-zone">
            <Field #default="{ errors, field, value }" :name="`Zone${zone.name}`"
              :rules="`integer|between:0,${zone.capacity}|matchBalancing:${balancingCapacity},${flight.paxs ? getPaxsByLeg.length : 0}`"
              v-model="autoPlacement[zone.name]">
              <v-text-field @update:model-value="field.onChange" :model-value="value" density="compact" class="mb-2 mr-2"
                type="number" min="0" :max="zone.capacity" :error-messages="errors" hide-details
                :disabled="flight.archived" :data-cy="'BalancyFormInputZone' + zone.name" :class="{
                  'background-color-zone-a': zone.name === 'OA',
                  'background-color-zone-b': zone.name === 'OB',
                  'background-color-zone-c': zone.name === 'OC',
                  'background-color-zone-d': zone.name === 'OD'
                }" variant="outlined">
                <span slot="prepend">
                  {{ zone.name }}
                </span>
              </v-text-field>
            </Field>
            /{{ zone.capacity }}
          </div>

          <div class="mb-4">
            CENTRAGE: <span class="font-weight-bold">{{ balancingCapacity }}/{{ totalCapacity }}</span>
          </div>

          <v-btn variant="outlined" rounded data-cy="SeatsBalancingAutoPlacementBtn" class="mb-4"
            :disabled="!meta.valid || flight.archived" :loading="loading" @click="askAutoplacement()" size="large">
            PLACEMENT AUTOMATIQUE
          </v-btn>

          <div class="mb-4">
            Schéma
          </div>
          <v-radio-group v-model="autoPlacement.autoPlacementModel" :disabled="flight.archived" class="mt-0">
            <v-radio label="Par rangées" data-cy="SeatsBalancingRadioRowBtn" :value="AutoPlacementModel.row">
            </v-radio>
            <v-radio label="Par colonnes extérieures" data-cy="SeatsBalancingRadioExternalBtn"
              :value="AutoPlacementModel.external">
            </v-radio>
            <v-radio label="Un siège sur deux" data-cy="SeatsBalancingRadioOneOnTwoBtn"
              :value="AutoPlacementModel.one_on_two">
            </v-radio>
          </v-radio-group>
        </div>
      </v-card-text>

      <LazyConfirmDialog v-if="confirmDialog" v-model="confirmDialog" :dialogText="confirmDialogText"
        :dialogTitle="confirmDialogTitle" @confirm="doAutoPlacement" @close="close" />
    </v-card>
  </div>
</template>

<script setup lang="ts">
import { AutoPlacementModel } from "~/dto/autoplacementmodel.enum";
import { Leg } from "~/dto/leg.dto";
import { Flight } from "~/dto/flight.dto";
import { Aircraft } from "~/dto/aircraft.dto";
import { Pax } from "~/dto/pax.dto";

const props = defineProps<{
  leg: Leg,
  flight: Flight,
  lockEvent: boolean
}>();

const emit = defineEmits(['autoPlacementDone'])

const autoPlacement: Ref<any> = ref({
  OA: 0,
  OB: 0,
  OC: 0,
  OD: 0,
  autoPlacementModel: AutoPlacementModel.row
});

const {validate, meta} = useForm({
  initialValues: autoPlacement
})

const store = useStore();

const zones: Ref<any[]> = ref([]);
const confirmDialog = ref(false);
const loading = ref(false);
const { $api, $toast } = useNuxtApp();

const confirmDialogTitle = 'Placement automatique'
const confirmDialogText = 'Des PAX ont déjà été placés. Un placement automatique leur ré-attribuera des places. Êtes-vous sûr de vouloir continuer ?'

const totalCapacity = computed(() => {
  return zones.value.reduce((a, b) => a + (b.capacity || 0), 0)
});

const aircrafts: Ref<Aircraft[]> = computed(() => {
  return store.aircrafts;
});

const balancingCapacity = computed(() => {
  return +autoPlacement.value.OA + +autoPlacement.value.OB + +autoPlacement.value.OC + +autoPlacement.value.OD;
});

const getPaxsByLeg: Ref<Pax[]> = computed(() => {
  return props.flight.paxs?.filter(p => p.legs?.findIndex(l => l.id === props.leg.id) >= 0);
});

const askAutoplacement = () => {
  if (props.leg.seats && props.leg.seats.findIndex(s => !!s.pax) >= 0) {
    confirmDialog.value = true;
  } else {
    doAutoPlacement();
  }
}

const doAutoPlacement = async () => {
  try {
    loading.value = true;
    props.leg.seats = await $api.leg.autoPlacement(autoPlacement.value, props.leg.id);
    props.leg.status = await $api.leg.getStatus(props.leg.id);
    emit('autoPlacementDone', true);
    $toast.success("Placement automatique effectué");
  } catch (e) {
    $toast.error("Erreur lors du placement automatique");
  }
  close();
}

const computeZoneCapacity = () => {
  zones.value.forEach(z => {
    const seatsLocked = props.leg.seats?.filter(s => s.zone === z.name && s.blocked).length;
    z.capacity = seatsLocked ? z.fullCapacity - seatsLocked : z.fullCapacity;
  });
  zones.value = JSON.parse(JSON.stringify(zones.value));
}

const close = () => {
  loading.value = false;
  confirmDialog.value = false;
}

watch(() => props.lockEvent, () => {
  computeZoneCapacity();
})

const zonesArray = aircrafts.value.find(a => a.name === props.flight?.aircraft?.name)?.seatsTemplate.map(s => s.zone);
if (!zonesArray) {
  throw '';
}
const uniqueZones = zonesArray.filter((v, i, a) => a.indexOf(v) === i).sort((a, b) => a.localeCompare(b));
uniqueZones.forEach(z => {
  zones.value.push({ name: z, fullCapacity: zonesArray.filter(x => x === z).length });
});
computeZoneCapacity();
const paxNumber = getPaxsByLeg.value.length;
zones.value.forEach((z, index) => {
  if (!props.leg.seats || props.leg.seats.length < 1 || !props.leg.seats.find(s => !!s.pax)) {
    autoPlacement.value[z.name] = Math.round(paxNumber * z.capacity / totalCapacity.value);
    if (index === zones.value.length - 1 && balancingCapacity.value !== paxNumber) {
      autoPlacement.value[z.name] = balancingCapacity.value < paxNumber ? autoPlacement.value[z.name] + 1 : autoPlacement.value[z.name] - 1;
    }
  } else if (props.leg.seats && props.leg.seats.length > 1) {
    autoPlacement.value[z.name] = props.leg.seats.filter(s => s.zone === z.name && !!s.pax).length;
  }
});


</script>

<style lang="scss">
@import "../../../../assets/variables.scss";

.seats-layout--fullscreen .balancy-card {
  left: 16px;
  top: 16px;
}

.balancy-card {
  position: absolute;
  left: 0;
  top: 0;
  z-index: 1;
}

.balancy-zones {
  display: flex;
  flex-direction: column;
  align-items: center;

  .balancy-zone {
    display: flex;
    align-items: center;
    width: 165px;

    .v-text-field--outlined.v-input {
      width: 125px;
      flex: initial;

      .v-input {
        &__control {
          background-color: $color-white;
          border-top-left-radius: 0;
          border-bottom-left-radius: 0;
        }

        &__slot {
          margin-bottom: 0;
        }

        &__prepend-outer {
          min-width: 60px;
          margin: 11px 0 0 0;
          color: $color-black;
          display: flex;
          justify-content: center;
        }
      }

      .v-text-field__details {
        display: none;
      }
    }
  }
}
</style>
